/* compilestr1.csd
   Use of compilestr, and scoreline_i to perform another
   defined instrument, listed within the outer instrument.
   J. Hearon
*/

<CsoundSynthesizer>
<CsOptions>
;-o dac -d
csound -s -d -+rtaudio=ALSA -odevaudio -b1024 -B16384  
</CsOptions>
<CsInstruments>


sr	=	44100
kr	=	4410
ksmps	=	10
nchnls	=	2
0dbfs = 1

instr 1

kenv linseg 0, p3*0.25, .5, p3*0.75, 0
a1	oscil	kenv, p4, p5
 	outs	a1, a1

ires compilestr {{
	instr	2002
kenv linseg 0, p3*0.25, .5, p3*0.75, 0
a1	oscil	kenv, p4, p5
 	outs	a1, a1
 	endin
}}
print ires ; ... and returns 0 if successful

 ;call the new instrument from within instr1
scoreline_i {{
            i 2002 0  5 400 1
            i 2002 6  5 500 2
            i 2002 12 5 600 3
            i 2002 18 5 500 4
            }}
endin

</CsInstruments>
<CsScore>
; One period of a sine wave
f 1	0	8192	10	1
; One period of an approximate sawtooth wave
f 2	0	8192	10	1 0.5 0.333 0.25 0.2 0.1667 0.1429 0.125 0.111 0.1
; One period of an approximate square wave
f 3	0	8192	10	1 0 0.333 0 0.2 0 0.1429 0 0.111 0
; One period of an approximate triangle wave
f 4	0	8192	10	1 0 -0.111 0 0.04 0 -0.0204 0 0.0123 0 -0.0083 0 0.0059

;f0 20 ;need if instr1 p3 is less than total dur of scoreline_i p3s.
i1 0  20 1200 4

</CsScore>
</CsoundSynthesizer>
