
/*
dir_ex1.csd

inst1 uses directory to load an array with a number of audio files,
previously formatted the same.  It then uses schedule to call instr2
to play the samples using diskin2, at i-rate.
Instr2 struggles with array length warnings so best to dimension your
own array to instr2.
J. Hearon
*/
 
<CsoundSynthesizer>
<CsOptions>
csound -s -d -+rtaudio=ALSA -odevaudio -b1024 -B16384 
</CsOptions>
<CsInstruments>

sr	=	48000
kr	=	4800
ksmps	=	10
nchnls	=	2
0dbfs = 1

giCntr init 0
giNum init 0
giArrLen  =        7
gSArr[]   init     giArrLen
;-------------------------------------
instr 1
;adjust path here as needed:
SFilenames[] directory "/opt/csound6-git/MetaExs/directory/mydirectory", ".wav"
iNumberOfFiles lenarray SFilenames
printf_i "***iNumberOfFiles = %d \n", 1, iNumberOfFiles
  idur = 5
  iwhen = 0
while giCntr < iNumberOfFiles do
  schedule 2, iwhen, idur
  iwhen = iwhen + 5
printf_i "***instr1, GiCntr = %d \n", 1, giCntr
giCntr = giCntr+1
od
endin
;-------------------------------------
instr 2
;adjust path here as needed:
gSArr[] directory "/opt/csound6-git/MetaExs/directory/mydirectory", ".wav"
iNumberOfFiles lenarray gSArr

printf_i "----instr2, GiNum = %d \n", 1, giNum

if (giNum == 6) then
turnoff
else
igoto play
endif

play:
ar1 diskin2 gSArr[giNum], 1, 0, 0, 0, 1, 0
outs ar1, ar1
giNum = giNum+1
end:
endin

</CsInstruments>
<CsScore>
i1 0 30
</CsScore>
</CsoundSynthesizer>


