/*
dir_ex2.csd
The Csound Manual mentions it is more efficient
to use an array to play several files when using diskin2.
This example shows instr2 using an a-rate array.
J. Hearon
*/
 
<CsoundSynthesizer>
<CsOptions>
csound -s -d -+rtaudio=ALSA -odevaudio -b1024 -B16384 
</CsOptions>
<CsInstruments>

sr	=	48000
kr	=	4800
ksmps	=	10
nchnls	=	2
0dbfs = 1

giCntr init 0
giNum init 0
gaArr[] init 7
giArrLen  =        7
gSArr[]   init     giArrLen
;-------------------------------------
instr 1
;adjust path here as needed:
SFilenames[] directory "/opt/csound6-git/MetaExs/directory/mydirectory", ".wav"
iNumberOfFiles lenarray SFilenames
printf_i "***iNumberOfFiles = %d \n", 1, iNumberOfFiles
  idur = 5
  iwhen = 0
while giCntr < iNumberOfFiles do
  schedule 2, iwhen, idur
  iwhen = iwhen + 5
printf_i "***instr1, GiCntr = %d \n", 1, giCntr
giCntr = giCntr+1
od
endin
;-------------------------------------
instr 2
;adjust path here as needed:
gSArr[] directory "/opt/csound6-git/MetaExs/directory/mydirectory", ".wav"
iNumberOfFiles lenarray gSArr

printf_i "----instr2, GiNum = %d \n", 1, giNum

if (giNum == 6) then
turnoff
else
igoto play
endif

play:
gaArr[giNum] diskin2 gSArr[giNum], 1, 0, 0, 0, 1, 0
outs gaArr[giNum], gaArr[giNum]
giNum = giNum+1
end:
endin

</CsInstruments>
<CsScore>
i1 0 30
</CsScore>
</CsoundSynthesizer>

