/*
ftsamplebank1.csd
Uses ftsamplebank to read a directory of similar formatted samples 
at the i-rate.
NOTE: start time for triggered play instrument needs to be greater
than 0, else invalid table number results for the first table
ex. (event_i idelay = iFileCount + 1).
Employs an until loop and the event opcode.
J. Hearon
*/


<CsoundSynthesizer>
<CsOptions>
csound -s -d -+rtaudio=ALSA -odevaudio -b1024 -B16384 
</CsOptions>
<CsInstruments>

sr	=	48000
kr	=	4800
ksmps	=	10
nchnls	=	2
0dbfs = 1

;load all samples in a given directory into function tables and play them using instrument 1000
instr 1
   iFirstTableNumber = 60;
   iFileCount init 0
   iTrig = 1
   ;adjust path here as needed
   iNumberOfFiles ftsamplebank "/opt/csound6-git/MetaExs/ftsamplebank/samples", iFirstTableNumber, iTrig, 0, 4, 0

printf_i "*********iNumberOfFiles = %d \n", 1, iNumberOfFiles

   until iFileCount >= iNumberOfFiles do
printf_i "*************iFileCount = %d \n", 1, iFileCount
//event_i "scorechar", iinsnum, idelay, idur, [, ip4] [, ip5] [, ...]
	event_i "i", 1000, iFileCount + 1, 1, iFirstTableNumber+iFileCount
	iFileCount = iFileCount+1
   enduntil
   
/* ;loop_lt 
ininstr = iNumberOfFiles ;number of called instances
indx = 0
loop:
printf_i "*************iFileCount = %d \n", 1, iFileCount
event_i "i", 1000, iFileCount, 1, iFirstTableNumber+iFileCount
	iFileCount = iFileCount+1
loop_lt indx, 1, ininstr, loop
*/

endin

instr 1000
   iTable = p4
printf_i "*************i1000, table = %d \n", 1, iTable
   aOut loscil3 1, 1, iTable, 1, 0;
   outs aOut, aOut
endin 

</CsInstruments>
<CsScore>
i1 0 8
</CsScore>
</CsoundSynthesizer>
