

/*
ftsamplebank1b.csd
Uses ftsamplebank to read a directory of similar formatted samples
at the i-rate.
NOTE: start time for triggered play instrument needs to be greater
than 0, else invalid table number results for the first table.
Employs a while loop and the schedule opcode.
J. Hearon
*/




<CsoundSynthesizer>
<CsOptions>
csound -s -d -+rtaudio=ALSA -odevaudio -b1024 -B16384 
</CsOptions>
<CsInstruments>

sr	=	48000
kr	=	4800
ksmps	=	10
nchnls	=	2
0dbfs = 1


instr 1

   iFirstTableNumber = 60;
   iFileCount init 0
   iTrig = 1
   iNumberOfFiles ftsamplebank "/opt/csound6-git/MetaExs/ftsamplebank/samples", iFirstTableNumber, iTrig, 0, 4, 0

printf_i "*********iNumberOfFiles = %d \n", 1, iNumberOfFiles

  idur = 1
  iwhen = 1
while iFileCount < iNumberOfFiles do
printf_i "***instr1, iFileCount = %d \n", 1, iFileCount
  schedule 1000, iwhen, idur,  iFirstTableNumber+iFileCount
  iwhen = iwhen + 1
  iFileCount = iFileCount+1
od

endin

instr 1000
   iTable = p4
printf_i "*************i1000, table = %d \n", 1, iTable
   aOut loscil3 1, 1, iTable, 1, 0;
   outs aOut, aOut
endin 

</CsInstruments>
<CsScore>
i1 0 8
</CsScore>
</CsoundSynthesizer>
