
/*
ftsamplebank2.csd
Uses ftsamplebank, at k-rate, to read a directory of similar formatted samples.
NOTE: start time for triggered play instrument needs to be greater
than 0, else invalid table number results for the first table
ex. (event_i kdelay = kFileCount + 1).
J. Hearon
*/

<CsoundSynthesizer>
<CsOptions>
csound -s -d -+rtaudio=ALSA -odevaudio -b1024 -B16384 
</CsOptions>
<CsInstruments>

sr	=	48000
kr	=	4800
ksmps	=	10
nchnls	=	2
0dbfs = 1

;load all samples in a given directory into function tables and play them using instrument 1000
instr 1
   kFirstTableNumber = 60;
   kFileCount init 0
   kTrig = 1

   ;adjust path here as needed
   kNumberOfFiles ftsamplebank "/opt/csound6-git/MetaExs/ftsamplebank/samples", kFirstTableNumber, kTrig, 0, 4, 0

  play:	
        event "i", 1000, kFileCount + 1 , 1, kFirstTableNumber+kFileCount
	kFileCount = kFileCount+1

        if (kFileCount < kNumberOfFiles) then
        kgoto play

        elseif (kFileCount >= kNumberOfFiles) then
        turnoff

        endif
endin

instr 1000
   iTable = p4
   aOut loscil3 1, 1, iTable, 1, 0;
   outs aOut, aOut
endin 
	
</CsInstruments>
<CsScore>
i1 0 8
</CsScore>
</CsoundSynthesizer>
