
/* this code calls the triangletest.csd from a thread
 * and opens a gl window and displays a triangle
*/

//gcc -Wall -w -O2 -DUSE_DOUBLE -I/opt/csound6-git -I/usr/include -L/usr/lib64  -lGL -lGLU -lglut -o triangletest triangletest.c -L. -lcsound64 -lsndfile -ldl -lm -lpthread -lfftw3


#include "GL/freeglut.h"
#include "GL/gl.h"
#include "stdio.h"
#include "stdlib.h"
#include "include/csound.h" 


uintptr_t csThread(void *clientData); 

typedef struct { 
  int result; 
  CSOUND *csound; 
  int PERF_STATUS; 
} userData; 


void drawTriangle()
{
    glClearColor(0.4, 0.4, 0.4, 0.4);
    glClear(GL_COLOR_BUFFER_BIT);

    glColor3f(1.0, 1.0, 1.0);
    glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0);

        glBegin(GL_TRIANGLES);
                glVertex3f(-0.7, 0.7, 0);
                glVertex3f(0.7, 0.7, 0);
                glVertex3f(0, -1, 0);
        glEnd();

    glFlush();
}

int main(void) 
{
  int finish;
  void *ThreadID; 
  userData *ud; 
  ud = (userData *)malloc(sizeof(userData));  
  MYFLT *pvalue; 
  
  //adjust options and paths here as needed
  const char *argv[] = {"csound", "-+rtaudio=ALSA", "-odac", "-s", "-d", "-b1024", "-B1024","/opt/csound6-git/MetaExs/include/triangletest.csd" };

 // fake argc and argv args for glutInit
 // since wer'e using main(void)
  char *myargv [1];
  int myargc=1;
  myargv [0]=strdup ("Myappname");
 //------------------------
    //glut init and create window
    glutInit(&myargc, myargv);
    glutInitDisplayMode(GLUT_SINGLE);
    glutInitWindowSize(500, 500);
    glutInitWindowPosition(100, 100);
    int win = glutCreateWindow("OpenGL - Creating a triangle");
    
  //create and compile csound  
  ud->csound = csoundCreate(NULL);  
  ud->result = csoundCompile(ud->csound, 8, (char **)argv);

  if (!ud->result) {  
    ud->PERF_STATUS = 1; 
    ThreadID = csoundCreateThread(csThread, (void *)ud); 

    //draw the glut gl triangle from the thread
    glutDisplayFunc(drawTriangle);
    glutMainLoop();

  } 
  else { 
    return 1; 
  }  

  //if click to close glut window then also csound will end
  void glutDestroyWindow(win);
  
  /* keep performing until user types a number and presses enter */
  //scanf("%d", &finish);


  ud->PERF_STATUS = 0; 
  csoundDestroy(ud->csound); 
  free(ud);  
  return 0; 
} 

/* performance thread function */
uintptr_t csThread(void *data) 
{ 
  userData *udata = (userData *)data; 
  if (!udata->result) {
    while ((csoundPerformKsmps(udata->csound) == 0) &&
           (udata->PERF_STATUS == 1));
    csoundDestroy(udata->csound); 
  }        
  udata->PERF_STATUS = 0;    
  return 1; 
}  
