/* readBoost.csd
 * Read and play text files from disc
 * J. Hearon
 */

<CsoundSynthesizer>
<CsOptions>
csound -s -d -+rtaudio=ALSA -odevaudio -b1024 -B16384 
</CsOptions>
<CsInstruments>

sr = 44100
ksmps = 32
nchnls = 2
0dbfs  = 1

giSine ftgen 0, 0, 2^10, 10, 1
;adjust path here as needed
gSname =  "/opt/csound6-git/MetaExs/readf/cauchy."
gSext init "something"
gSwholename init "something"

;---------------------------------
instr 1 ;event_i i-rate

icntr init 0;
iNumberOfFiles init 5;
iname init 0;
iwhen init 0;
idur init 3;

while icntr < iNumberOfFiles do
print icntr, iname
event_i "i", 2, iwhen, idur, iname
iwhen += idur
icntr += 1
iname += 1
od

endin

;---------------------------

instr 2  ; read files, segfaults if type 8

itrig init 1;
gSext sprintf "%d", p4 ;convert kcntr to string
printf_i  "ext is now: '%s'\n", itrig, gSext
gSwholename strcat gSname, gSext ;concat strings
printf_i  "filename is now: '%s'\n", itrig, gSwholename

kfreq readk  gSwholename, 7, .25
      if (kfreq > 0) then
      printk2 kfreq
      endif
aout  poscil 1, kfreq, giSine
      outs   aout, aout
endin



</CsInstruments>
<CsScore>
 i 1 1 25
</CsScore>
e
</CsScore>
</CsoundSynthesizer>
