/* readk.csd
   A pure Csound example to
   write files to disk,
   each one contains random numbers.
   Then read back from the files to play audio.
   See the also readk ex.csd from the Csound manual.
   J. Hearon
*/


<CsoundSynthesizer>
<CsOptions>
csound -s -d -+rtaudio=ALSA -odevaudio -b1024 -B16384 
</CsOptions>
<CsInstruments>

sr = 44100
ksmps = 32
nchnls = 2
0dbfs  = 1

giSine ftgen 0, 0, 2^10, 10, 1
;adjust path here as needed:
gSname =  "/opt/csound6-git/MetaExs/readf/test."
gSext init "something"
gSwholename init "something"

;---------------------------------
instr 1 ;write files, irate

icntr init 0
ifreq init 0

 until icntr >= 5 do
iprint init 0
gSext sprintf "%d", int(icntr)
Sout strcat gSname, gSext
;puts Sout, icntr
  while iprint < 10 do 
ifreq random 300, 2300 
fprints Sout, "%f\n", ifreq
  iprint = iprint + 1
  od
icntr = icntr + 1
enduntil
endin

;---------------------------------
instr 2 ;event_i i-rate

icntr init 0;
iNumberOfFiles init 5;
iname init 0;
iwhen init 0;
idur init 3;

while icntr < iNumberOfFiles do
print icntr, iname
event_i "i", 3, iwhen, idur, iname
iwhen += idur
icntr += 1
iname += 1
od

endin

;---------------------------

instr 3  ; read files, segfaults if type 8

itrig init 1;
gSext sprintf "%d", p4 ;convert kcntr to string
printf_i  "ext is now: '%s'\n", itrig, gSext
gSwholename strcat gSname, gSext ;concat strings
printf_i  "filename is now: '%s'\n", itrig, gSwholename

kfreq readk  gSwholename, 7, .25
      if (kfreq > 0) then
      printk2 kfreq
      endif
aout  poscil 1, kfreq, giSine
      outs   aout, aout
endin



</CsInstruments>
<CsScore>
 i 1 0 5
 i 2 6 25
e
</CsScore>
</CsoundSynthesizer>
